package com.ablecloud.weixin.common;

import com.ablecloud.common.ACConfig;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by chenpeng on 15-3-14.
 */
public class ACWXConfig extends ACConfig {

    private PropertiesConfiguration config;

    public ACWXConfig(String configFile) throws ConfigurationException {
        config = new PropertiesConfiguration(configFile);
    }

    public long getDeveloperId() {
        return config.getInt("developer_id", 0);
    }

    public String getAuthAccessKey() {
        return config.getString("access_key", "");
    }

    public String getAuthSecretKey() {
        return config.getString("secret_key", "");
    }

    public String getMajorDomain() {
        return config.getString("major_domain", "");
    }

    public String getRouterAddr() {
        String addr = super.getRouterAddr();
        if (addr == null || addr.isEmpty()) {
            String routerAddrs = config.getString("router_addr", "");
            setRouterAddr(routerAddrs);
            addr = super.getRouterAddr();
        }
        return addr;
    }

    public String getMode() {
        return config.getString("mode", "test");
    }

    public String getAppId() {
        return config.getString("app_id", "");
    }

    public String getAppSecret() {
        return config.getString("app_secret", "");
    }

    public String getToken() {
        return config.getString("token", "");
    }

    public String getHost() {
        return config.getString("host", "0.0.0.0");
    }

    public int getPort() {
        return config.getInt("port", 80);
    }

    public String getDefaultDeviceName() {
        return config.getString("default_device_name", "");
    }
}