package com.ablecloud.weixin.common;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

/**
 * Created by chenpeng on 15-3-14.
 */
public class ACWXSigner {
    public static String genSignature(String... strs) throws NoSuchAlgorithmException {
        Arrays.sort(strs);
        StringBuilder sb = new StringBuilder();
        for (String str : strs) {
            sb.append(str);
        }

        MessageDigest sha1 = MessageDigest.getInstance("SHA1");
        sha1.update(sb.toString().getBytes());
        byte[] result = sha1.digest();
        return bytesToHex(result);
    }

    protected static String bytesToHex(byte[] bytes) {
        char hexDigit[] = { '0', '1', '2', '3', '4',
                            '5', '6', '7', '8', '9',
                            'a', 'b', 'c', 'd', 'e', 'f'};
        StringBuffer buf = new StringBuffer();
        for (int i = 0; i < bytes.length; i++) {
            buf.append(hexDigit[(bytes[i] >> 4) & 0x0f]);
            buf.append(hexDigit[bytes[i] & 0x0f]);
        }
        return buf.toString();
    }
}
