package com.ablecloud.weixin.common;

/**
 * Created by chenpeng on 15/3/15.
 */
public class ACWXXmlResp {
    // text response message
    public static final String TEXT = new StringBuilder()
            .append("<xml>")
            .append("<ToUserName><![CDATA[%s]]></ToUserName>")
            .append("<FromUserName><![CDATA[%s]]></FromUserName>")
            .append("<CreateTime>%s</CreateTime>")
            .append("<MsgType><![CDATA[%s]]></MsgType>")
            .append("<Content><![CDATA[%s]]></Content>")
            .append("</xml>").toString();

    // device response message
    public static final String DEVICE_TEXT = new StringBuilder()
            .append("<xml>")
            .append("<ToUserName><![CDATA[%s]]></ToUserName>")
            .append("<FromUserName><![CDATA[%s]]></FromUserName>")
            .append("<CreateTime>%s</CreateTime>")
            .append("<MsgType><![CDATA[%s]]></MsgType>")
            .append("<DeviceType><![CDATA[%s]]></DeviceType>")
            .append("<DeviceID><![CDATA[%s]]></DeviceID>")
            .append("<SessionID>%s</SessionID>")
            .append("<Content><![CDATA[%s]]></Content>")
            .append("</xml>").toString();

    // device status response message
    public static final String DEVICE_STATUS = new StringBuilder()
            .append("<xml>")
            .append("<ToUserName><![CDATA[%s]]></ToUserName>")
            .append("<FromUserName><![CDATA[%s]]></FromUserName>")
            .append("<CreateTime>%s</CreateTime>")
            .append("<MsgType><![CDATA[%s]]></MsgType>")
            .append("<DeviceType><![CDATA[%s]]></DeviceType>")
            .append("<DeviceID><![CDATA[%s]]></DeviceID>")
            .append("<DeviceStatus>%d</DeviceStatus>")
            .append("</xml>").toString();

    // build text response message
    public static final String buildTextResp(String toUser, String fromUser, String content) {
        return String.format(TEXT, toUser, fromUser, getSystemTimeS(), ACWXMsgType.TEXT, content);
    }

    // build device response message
    public static final String buildDeviceTextResp(String fromUser, String toUser,
                                                   String deviceType, String deviceID,
                                                   String content, String sessionID) {
        return String.format(DEVICE_TEXT, fromUser, toUser, getSystemTimeS(),
                            ACWXMsgType.DEVICE_TEXT, deviceType, deviceID, sessionID, content);
    }

    public static final String buildDeviceStatusResp(String fromUser, String toUser,
                                                     String deviceType, String deviceId,
                                                     int deviceStatus) {
        return String.format(DEVICE_STATUS, fromUser, toUser, getSystemTimeS(),
                            ACWXMsgType.DEVICE_STATUS, deviceType, deviceId, deviceStatus);
    }

    private static String getSystemTimeS() {
        return String.valueOf(System.currentTimeMillis() / 1000);
    }
}
