package com.ablecloud.weixin.service;

import com.ablecloud.utils.ACSigner;
import com.ablecloud.weixin.common.ACWXSigner;
import com.ablecloud.weixin.utils.JsApiTicketKeeper;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Random;

/**
 * WiFi设备AirKiss界面。
 */
public class ACWXAirKissServlet extends ACWXServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        //TODO check
        try {
            StringBuilder strBuilder = new StringBuilder();
            String appId = ACWXServer.config.getAppId();
            String timestamp = strBuilder.append(System.currentTimeMillis() / 1000).toString();
            String nonceStr = genNonce(System.currentTimeMillis(), 16);
            String url = getOriginalRequestURL(req, true);
            strBuilder = new StringBuilder();
            strBuilder.append("jsapi_ticket=" + JsApiTicketKeeper.getTicketStr());
            strBuilder.append("&noncestr=" + nonceStr);
            strBuilder.append("&timestamp=" + timestamp);
            strBuilder.append("&url=" + url);
            String signature = ACWXSigner.genSignature(strBuilder.toString());
            strBuilder = new StringBuilder("<!DOCTYPE html>");
            strBuilder.append("<html lang=\"en\">");
            strBuilder.append("<head>");
            strBuilder.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
            strBuilder.append("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />");
            strBuilder.append("<title>AbleCloud &amp; 微信 - Airkiss</title>");
            strBuilder.append("</head>");
            strBuilder.append("<body><p>正在打开配置页面……</p></body>");
            strBuilder.append("<script src=\"http://res.wx.qq.com/open/js/jweixin-1.0.0.js\" type=\"text/javascript\"></script>");
            strBuilder.append("<script type=\"text/javascript\">");
            strBuilder.append("wx.config({beta:true, debug:false, appId:'" + appId + "', timestamp:" + timestamp + ", nonceStr:'" + nonceStr + "', signature:'" + signature + "', jsApiList:['configWXDeviceWiFi']});");
            strBuilder.append("wx.ready(function () {wx.invoke('configWXDeviceWiFi', {}, function(res){if (res.err_msg === 'configWXDeviceWiFi:ok') {document.write('<p>配置成功，等待服务器回应……</p>'); window.document.location.href = '" + getRootURL(req) + "/weixin/oauth2';} else if (res.err_msg === 'configWXDeviceWiFi:cancel') {document.write('<p>您取消了AirKiss配置。</p>');} else {document.write('<p>AirKiss配置失败：' + res.err_msg + '</p>');}});});");
            strBuilder.append("</script>");
            strBuilder.append("</html>");
            writeHtmlResp(strBuilder.toString(), resp);
        } catch (Exception e) {
            e.printStackTrace();
            writeHtmlResp("", resp);
        }
    }

    private String genNonce(long seed, int length) {
        String base = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYAC0123456789";
        Random random = new Random();
        random.setSeed(seed);
        StringBuilder sb = new StringBuilder(length);
        for (int i = 0; i < length; i++) {
            sb.append(base.charAt(random.nextInt(base.length())));
        }
        return sb.toString();
    }
}
